/* f_term.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b4 = 0.;
static logical c_false = FALSE_;
static integer c__3 = 3;
static integer c__1 = 1;
static doublereal c_b19 = 1e-13;
static logical c_true = TRUE_;
static doublereal c_b134 = 3.;
static doublereal c_b136 = 2.;
static doublereal c_b137 = 1.;
static doublereal c_b139 = 1.5;
static doublereal c_b147 = 1e-15;

/* $Procedure      F_TERM ( Test terminator routines ) */
/* Subroutine */ int f_term__(logical *ok)
{
    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    integer s_rnge(char *, integer, char *, integer);

    /* Local variables */
    integer npts;
    extern /* Subroutine */ int zzedterm_(char *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, integer *, doublereal *,
	     ftnlen);
    doublereal a, b, c__, d__;
    integer i__;
    doublereal r__;
    extern /* Subroutine */ int tcase_(char *, ftnlen);
    doublereal xdiff;
    extern /* Subroutine */ int vpack_(doublereal *, doublereal *, doublereal 
	    *, doublereal *), repmi_(char *, char *, integer *, char *, 
	    ftnlen, ftnlen, ftnlen);
    char title[80];
    extern /* Subroutine */ int topen_(char *, ftnlen);
    doublereal trans[9]	/* was [3][3] */;
    extern doublereal twopi_(void);
    extern /* Subroutine */ int t_success__(logical *);
    extern doublereal pi_(void);
    extern /* Subroutine */ int chcksd_(char *, doublereal *, char *, 
	    doublereal *, doublereal *, logical *, ftnlen, ftnlen), chckxc_(
	    logical *, char *, logical *, ftnlen), reclat_(doublereal *, 
	    doublereal *, doublereal *, doublereal *);
    doublereal londif;
    logical umbral;
    doublereal radius, gridpt[3], trmgrd[3000]	/* was [3][1000] */;
    extern /* Subroutine */ int twovec_(doublereal *, integer *, doublereal *,
	     integer *, doublereal *);
    doublereal srcpos[3], prvlon, lat, lon;
    extern /* Subroutine */ int mxv_(doublereal *, doublereal *, doublereal *)
	    , t_eterm__(char *, logical *, doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *, logical *,
	     ftnlen);

/* $ Abstract */

/*     Test the SPICELIB terminator routines. */

/* $ Particulars */

/*     Currently this test suite is limited to routines that */
/*     deal with ellipsoids. */

/* $ Version */

/* -    TSPICE Version 1.0.0, 31-JAN-2007  (NJB) */


/* -& */

/*     Test Utility Functions */


/*     SPICELIB functions */

/*      DOUBLE PRECISION      DPR */

/*     Local parameters */


/*     Local Variables */


/*     Begin every test family with an open call. */

    topen_("F_TERM", (ftnlen)6);

/* --- Case -------------------------------------------------------- */

    tcase_("Spherical target, D/R = 2, on z-axis, umbral case", (ftnlen)49);
    d__ = 2e6;
    vpack_(&c_b4, &c_b4, &d__, srcpos);
    a = 1e4;
    b = a;
    c__ = a;
    r__ = d__ / 2 + a;
    npts = 360;
    zzedterm_("UMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)6);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    umbral = TRUE_;
    prvlon = 0.;
    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);

/*        Check that the grid point is a tangency point of */
/*        a plane that is also tangent to the light source. */
/*        Also check that the center of the source is on the */
/*        correct side of the plane. */

	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)136)], ok, (ftnlen)80);

/*        Validate spacing of grid points:  longitude deltas */
/*        should be constant.  To avoid problems with singularities, */
/*        we work in a frame where SRCPOS is on the +Z axis and */
/*        the component of the first grid point orthogonal to the */
/*        +Z axis lies on the +X axis. */

	if (i__ == 1) {
	    twovec_(srcpos, &c__3, trmgrd, &c__1, trans);
	}
	mxv_(trans, &trmgrd[(i__2 = i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : 
		s_rnge("trmgrd", i__2, "f_term__", (ftnlen)152)], gridpt);
	reclat_(gridpt, &radius, &lon, &lat);
	if (lon < 0.) {
	    lon += twopi_();
	}
	if (i__ == 2) {

/*           We don't know the expected sign of the difference, but we */
/*           know the expected magnitude. */

	    xdiff = lon - prvlon;
	    if (xdiff > pi_()) {
		xdiff -= twopi_();
	    }
	    d__1 = abs(xdiff);
	    d__2 = twopi_() / npts;
	    chcksd_("ABS(XDIFF)", &d__1, "~", &d__2, &c_b19, ok, (ftnlen)10, (
		    ftnlen)1);
	} else if (i__ > 2) {
	    londif = lon - prvlon;
	    chcksd_("LONDIF", &londif, "~", &xdiff, &c_b19, ok, (ftnlen)6, (
		    ftnlen)1);
	}
/*         WRITE (*,*) RADIUS,LON*DPR(), LAT*DPR() */
	prvlon = lon;
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Spherical target, D/R = 2, on z-axis, penumbral case", (ftnlen)52)
	    ;
    d__ = 2e6;
    vpack_(&c_b4, &c_b4, &d__, srcpos);
    a = 1e4;
    b = a;
    c__ = a;
    r__ = d__ / 2 + a;
    npts = 6;
    zzedterm_("PENUMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)
	    9);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    umbral = FALSE_;
    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)224)], ok, (ftnlen)80);
	reclat_(&trmgrd[(i__2 = i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : 
		s_rnge("trmgrd", i__2, "f_term__", (ftnlen)227)], &radius, &
		lon, &lat);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Slightly prolate target, D/R = 2, on z-axis", (ftnlen)43);
    d__ = 2e6;
    vpack_(&c_b4, &c_b4, &d__, srcpos);
    a = 1e4;
    b = a - 1e3;
    c__ = a - 1e3;
    r__ = a + 1e6;
    npts = 1000;
    umbral = TRUE_;
    zzedterm_("UMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)6);
    chckxc_(&c_false, " ", ok, (ftnlen)1);
    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)261)], ok, (ftnlen)80);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Geometry comparable to Sun-Earth, umbral case", (ftnlen)45);
    d__ = 1.5e8;
    vpack_(&d__, &c_b4, &c_b4, srcpos);
    a = 6378.;
    b = a;
    c__ = 6357.;
    r__ = 1e6;
    npts = 360;
    zzedterm_("UMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)6);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    umbral = TRUE_;
    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)300)], ok, (ftnlen)80);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Geometry comparable to Sun-Earth, penumbral case", (ftnlen)48);
    d__ = 1.5e8;
    vpack_(&d__, &c_b4, &c_b4, srcpos);
    a = 6378.;
    b = a;
    c__ = 6357.;
    r__ = 1e6;
    npts = 360;
    umbral = FALSE_;
    zzedterm_("PENUMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)
	    9);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)338)], ok, (ftnlen)80);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Source and target have equal size, umbral case", (ftnlen)46);
    d__ = 1.5e8;
    vpack_(&d__, &c_b4, &c_b4, srcpos);
    a = 6378.;
    b = a;
    c__ = a;
    r__ = a;
    npts = 360;
    umbral = TRUE_;
    zzedterm_("UMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)6);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)375)], ok, (ftnlen)80);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Source and target have equal size, penumbral case", (ftnlen)49);
    d__ = 1.5e8;
    vpack_(&d__, &c_b4, &c_b4, srcpos);
    a = 6378.;
    b = a;
    c__ = a;
    r__ = a;
    npts = 360;
    umbral = FALSE_;
    zzedterm_("PENUMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)
	    9);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)412)], ok, (ftnlen)80);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Source is smaller than target, umbral case", (ftnlen)42);
    d__ = 1.5e8;
    vpack_(&d__, &c_b4, &c_b4, srcpos);
    a = 6378.;
    b = a;
    c__ = a;
    r__ = a / 2;
    npts = 360;
    umbral = TRUE_;
    zzedterm_("UMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)6);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)448)], ok, (ftnlen)80);
    }

/* --- Case -------------------------------------------------------- */

    tcase_("Source is smaller than target, penumbral case", (ftnlen)45);
    d__ = 1.5e8;
    vpack_(&d__, &c_b4, &c_b4, srcpos);
    a = 6378.;
    b = a;
    c__ = a;
    r__ = a / 2;
    npts = 360;
    umbral = TRUE_;
    zzedterm_("UMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)6);
    chckxc_(&c_false, " ", ok, (ftnlen)1);

/*     Make sure each point found is a terminator point. */

    i__1 = npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	s_copy(title, "Point *,", (ftnlen)80, (ftnlen)8);
	repmi_(title, "*", &i__, title, (ftnlen)80, (ftnlen)1, (ftnlen)80);
	t_eterm__(title, &umbral, srcpos, &r__, &a, &b, &c__, &trmgrd[(i__2 = 
		i__ * 3 - 3) < 3000 && 0 <= i__2 ? i__2 : s_rnge("trmgrd", 
		i__2, "f_term__", (ftnlen)485)], ok, (ftnlen)80);
    }


/*     Error handling tests follow. */



/* --- Case -------------------------------------------------------- */

    tcase_("Bad terminator type.", (ftnlen)20);
    zzedterm_("PNUMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)
	    8);
    chckxc_(&c_true, "SPICE(NOTSUPPORTED)", ok, (ftnlen)19);

/* --- Case -------------------------------------------------------- */

    tcase_("Bad grid size", (ftnlen)13);
    npts = 0;
    zzedterm_("PENUMBRAL", &a, &b, &c__, &r__, srcpos, &npts, trmgrd, (ftnlen)
	    9);
    chckxc_(&c_true, "SPICE(INVALIDSIZE)", ok, (ftnlen)18);

/* --- Case -------------------------------------------------------- */

    tcase_("Bad ellipsoid axis", (ftnlen)18);
    npts = 4;
    zzedterm_("PENUMBRAL", &c_b4, &b, &c__, &r__, srcpos, &npts, trmgrd, (
	    ftnlen)9);
    chckxc_(&c_true, "SPICE(INVALIDAXISLENGTH)", ok, (ftnlen)24);
    zzedterm_("PENUMBRAL", &a, &c_b4, &c__, &r__, srcpos, &npts, trmgrd, (
	    ftnlen)9);
    chckxc_(&c_true, "SPICE(INVALIDAXISLENGTH)", ok, (ftnlen)24);
    zzedterm_("PENUMBRAL", &a, &b, &c_b4, &r__, srcpos, &npts, trmgrd, (
	    ftnlen)9);
    chckxc_(&c_true, "SPICE(INVALIDAXISLENGTH)", ok, (ftnlen)24);

/* --- Case -------------------------------------------------------- */

    tcase_("Bad light source radius", (ftnlen)23);
    npts = 4;
    zzedterm_("PENUMBRAL", &a, &b, &c__, &c_b4, srcpos, &npts, trmgrd, (
	    ftnlen)9);
    chckxc_(&c_true, "SPICE(INVALIDRADIUS)", ok, (ftnlen)20);

/* --- Case -------------------------------------------------------- */

    tcase_("Light source and target are too close", (ftnlen)37);
    npts = 4;
    vpack_(&c_b4, &c_b4, &c_b134, srcpos);
    zzedterm_("UMBRAL", &c_b136, &c_b137, &c_b137, &c_b139, srcpos, &npts, 
	    trmgrd, (ftnlen)6);
    chckxc_(&c_true, "SPICE(OBJECTSTOOCLOSE)", ok, (ftnlen)22);
    t_success__(ok);
    return 0;
} /* f_term__ */



/*     Utility functions: */



/*     Check a terminator point on an ellipsoid. */

/* Subroutine */ int t_eterm__(char *title, logical *umbral, doublereal *
	srcpos, doublereal *srcrad, doublereal *a, doublereal *b, doublereal *
	c__, doublereal *x, logical *ok, ftnlen title_len)
{
    /* System generated locals */
    doublereal d__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    extern doublereal vdot_(doublereal *, doublereal *);
    extern /* Subroutine */ int vsub_(doublereal *, doublereal *, doublereal *
	    );
    doublereal d__, h__, n[3];
    char label[80];
    doublereal scale, plane[4], nearp[3];
    extern doublereal vdist_(doublereal *, doublereal *), vnorm_(doublereal *)
	    ;
    extern /* Subroutine */ int vprjp_(doublereal *, doublereal *, doublereal 
	    *), nvp2pl_(doublereal *, doublereal *, doublereal *), chcksd_(
	    char *, doublereal *, char *, doublereal *, doublereal *, logical 
	    *, ftnlen, ftnlen);
    doublereal offset[3];
    extern /* Subroutine */ int suffix_(char *, integer *, char *, ftnlen, 
	    ftnlen), surfnm_(doublereal *, doublereal *, doublereal *, 
	    doublereal *, doublereal *);


/*     SPICELIB functions */


/*     Local parameters */


/*     Local variables */


/*     Get the ellipsoid's outward normal vector at X. */

    surfnm_(a, b, c__, x, n);

/*     Form the tangent plane at X. */

    nvp2pl_(n, x, plane);

/*     The center of the source should be below the tangent */
/*     plane in the umbral case and above the plane in the */
/*     penumbral case. */

    s_copy(label, title, (ftnlen)80, title_len);
    suffix_("<N,SRCPOS>", &c__1, label, (ftnlen)10, (ftnlen)80);
    vsub_(srcpos, x, offset);
    if (*umbral) {
	d__1 = vdot_(n, offset);
	chcksd_(label, &d__1, "<", &c_b4, &c_b147, ok, (ftnlen)80, (ftnlen)1);
    } else {
	d__1 = vdot_(n, offset);
	chcksd_(label, &d__1, ">", &c_b4, &c_b147, ok, (ftnlen)80, (ftnlen)1);
    }
    if (! (*ok)) {
	return 0;
    }

/*     Find the nearest point on the plane to the center */
/*     of the light source. */

    vprjp_(srcpos, plane, nearp);

/*     Find the plane's height relative to the source's */
/*     surface. */

    h__ = vdist_(nearp, srcpos) - *srcrad;

/*     Determine the scale that should be used for the */
/*     coming relative error computation. */

    d__ = vnorm_(srcpos);
/* Computing MAX */
    d__1 = max(d__,*srcrad), d__1 = max(d__1,*a), d__1 = max(d__1,*b);
    scale = max(d__1,*c__);
    s_copy(label, title, (ftnlen)80, title_len);
    suffix_("ABS(H)/SCALE", &c__1, label, (ftnlen)12, (ftnlen)80);
    d__1 = abs(h__) / scale;
    chcksd_(title, &d__1, "~", &c_b4, &c_b147, ok, title_len, (ftnlen)1);
    return 0;
} /* t_eterm__ */

